AchievementAllGasNoBreaks = class(Turbine.UI.Control)
function AchievementAllGasNoBreaks:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Bash"] = true,
        ["Shield-blow"] = true,
        ["Shield-taunt"] = true,
        ["Shield Wall"] = true,
        ["Shield-smash"] = true,
        ["Juggernaut"] = true,
    }

    self.handler = handler

    self.Command = Turbine.ShellCommand()
    function self.Command:Execute()
        HardcoreHandler:GetAchievementHint("All Gas No Breaks")
    end

    Turbine.Shell.AddCommand("hardcoreallgasnobreaks", self.Command)
    ChatOutput("Use the command /hardcoreallgasnobreaks to see a list of affected skills")

    self:SetCallbacks()
end

function AchievementAllGasNoBreaks:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then
            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("All Gas No Breaks", "Usage of an illegal skill", 0x410081FF)
            end))
        end
    end
end

function AchievementAllGasNoBreaks:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
end

function AchievementAllGasNoBreaks:Refresh()
    self:Unload()
    self:SetCallbacks()
end


function AchievementAllGasNoBreaks:GetHint()
    ChatOutput("<rgb=#005500>Only non shield skills can be used.")
    ChatOutput("<rgb=#FF0000>Skills that are not allowed:")
    for key, value in PrimeUtils.Utils.spairs(self.skillList, function(t, a, b) return a < b end) do
       ChatOutput(key)
    end
end